#!/usr/bin/python
#-*- coding: utf-8 -*-

#import tkinter
#Traceback (most recent call last):
#  File "<pyshell#11>", line 1, in <module>
#    import tkinter
#ImportError: No module named tkinter

#import sys, Tkinter
#sys.modules['tkinter'] = Tkinter # put the module where python looks first for modules
#import tkinter # now works!

import os, sys, tkinter
import RPi.GPIO as GPIO
import time
import pygame
pygame.mixer.init()

from tkinter import *
from itertools import count

# ustawienia poruszania silnika
PWMPin = 12 # Pin PWM podłączony do ENA.
Motor1 = 8 # Podłączony do Wejścia 1.
Motor2 = 10 # Podłączony do Wejścia 2.
GPIO.setwarnings(False)
GPIO.setmode(GPIO.BOARD)
GPIO.setup(PWMPin, GPIO.OUT) # Ustawiliśmy tryb pracy naszego pinu na wyjście
GPIO.setup(Motor1, GPIO.OUT)
GPIO.setup(Motor2, GPIO.OUT)
GPIO.output(PWMPin, GPIO.LOW) # Kiedy się uruchomi, wszystkie piny będą LOW.
GPIO.output(Motor1, GPIO.LOW)
GPIO.output(Motor2, GPIO.LOW)
PwmValue = GPIO.PWM(PWMPin, 2000) # Ustawiliśmy naszą częstotliwość PWM na 2000.
PwmValue.start(100) # To jest maksymalna wartość – 100 %.

kb = tkinter.Tk()
kb.attributes("-fullscreen", True)
kb.configure(background='steelblue')

class Question:
    def __init__(self, question, answer):
        self.question = question
        self.answer = answer

    def check(self, answ, kb):
        global right
        if(answ == self.answer):
            obrazekdobrze()
            label = Label(kb, font=("Century Gothic", 20), height=3, background='steelblue', text="Dobrze Ci idzie! Oby tak dalej!")
            label.grid(row=8,columnspan=15)
            pygame.mixer.music.load("/home/pi/zagadkomat/good.wav")
            pygame.mixer.music.play()
            right += 1
            kb.after(1000, lambda: rozwinzwin())
            kb.after(1000, lambda: label.grid_forget())
            kb.after(1000, lambda: pytanie.grid_forget())
            kb.after(1000, lambda: entry.grid_forget())
            kb.after(1000, lambda: przycisk.grid_forget())
            kb.after(1000, lambda: obrazeknormal())
            kb.after(1000, lambda: askQuestion())
        
        else:
            obrazekzle()
            label = Label(kb, font=("Century Gothic", 20), background='steelblue', height=3, text="To zła odpowiedź! Nie możesz przejsć dalej.")
            label.grid(row=8,columnspan=15)
            pygame.mixer.music.load("/home/pi/zagadkomat/bad.wav")
            pygame.mixer.music.play()
            kb.after(1000, lambda: label.grid_forget())
            kb.after(1000, lambda: obrazeknormal())
            kb.after(1000, lambda: entry.delete(0, END))            

    def getView(self):
        global pytanie
        pytanie = Label(kb, text=self.question, fg='white', bg="steelblue", font=("Century Gothic", 14), wraplength=680)
        pytanie.grid(row=0,column=5,rowspan=2,columnspan=10)

        global entry
        entry = Entry(kb, width=40, font=("Century Gothic", 20), justify='center')
        entry.grid(row=2,column=5,rowspan=2,columnspan=10)
        
        global przycisk
        przycisk = Button(kb, text="ODPOWIEDZ", bg="#3c4987", fg="#ffffff", activebackground = "#ffffff", activeforeground="#3c4987", font=("Century Gothic", 30), command=lambda *args: self.check(entry.get(), kb))
        przycisk.grid(row=8,column=0,columnspan=15)

def napisz():
    label2 = Label(kb, text=entry.get())
    label2.grid(row=2,columnspan=15)
    
def askQuestion():
    global questions, kb, index, button, right, number_of_questions
    czesc.grid_forget()
    button.grid_forget()
    if(len(questions) == index + 1):
        index = 1
        obrazekdobrze()
        koncowyl = Label(kb, text="Wszystkie zagadki zostały rozwiązane. Gratulacje!", bg='steelblue', fg="#ffffff", font=("Century Gothic", 20), height = 1)        
        koncowyl.grid(row=0,column=5,rowspan=2,columnspan=10)
        koncowy = Button(kb, text="Od nowa", bg="#3c4987", fg="#ffffff", activebackground = "#ffffff", activeforeground="#3c4987", font=("Century Gothic", 40), height = 1, width = 15, command=odnowa)        
        koncowy.grid(row=2,column=5,rowspan=2,columnspan=10)
    index += 1
    kb.after(0, lambda: questions[index].getView())

def odnowa():
    os.execv(sys.executable, ['python3'] + sys.argv)

def rozwinzwin():
    GPIO.output(Motor1, GPIO.LOW) # Rozwijanie
    GPIO.output(Motor2, GPIO.HIGH)
    time.sleep(1.4)
    GPIO.output(Motor1, GPIO.HIGH) # Zwijanie
    GPIO.output(Motor2, GPIO.LOW)
    time.sleep(2)
    GPIO.output(Motor1, GPIO.LOW) # Stop
    GPIO.output(Motor2, GPIO.LOW)

def rozwin():
    GPIO.output(Motor1, GPIO.LOW) # Rozwijanie
    GPIO.output(Motor2, GPIO.HIGH)
    time.sleep(1)
    GPIO.output(Motor1, GPIO.LOW) # Stop
    GPIO.output(Motor2, GPIO.LOW)

def zwin():
    GPIO.output(Motor1, GPIO.HIGH) # Zwijanie
    GPIO.output(Motor2, GPIO.LOW)
    time.sleep(1)
    GPIO.output(Motor1, GPIO.LOW) # Stop
    GPIO.output(Motor2, GPIO.LOW)

def koniec():
    pozeg = Label(kb, width=42, height=13, text="Po wyłączeniu się systemu, wyłącz wyłącznik po prawej stronie. Dziękuję.", fg='white', bg="steelblue", font=("Century Gothic", 30), wraplength=870)
    pozeg.grid(row=0,column=0,rowspan=9,columnspan=15)
    kb.after(4000, lambda: os.system('sudo poweroff'))

def obrazekdobrze():
    photo = PhotoImage(file="/home/pi/zagadkomat/robot-2.gif")
    label = Label(image=photo, borderwidth=0)
    label.image = photo # keep a reference!
    label.grid(row=1,column=0,rowspan=2,columnspan=5)

def obrazekzle():
    photo = PhotoImage(file="/home/pi/zagadkomat/robot-3.gif")
    label = Label(image=photo, borderwidth=0)
    label.image = photo # keep a reference!
    label.grid(row=1,column=0,rowspan=2,columnspan=5)

def obrazeknormal():
    photo = PhotoImage(file="/home/pi/zagadkomat/robot-1.gif")
    label = Label(image=photo, borderwidth=0)
    label.image = photo # keep a reference!
    label.grid(row=1,column=0,rowspan=2,columnspan=5)

def select(value):
    if value == "BACK":
        # allText = entry.get()[:-1]
        # entry.delete(0, tkinter,END)
        # entry.insert(0,allText)

        entry.delete(len(entry.get())-1,tkinter.END)
        
    elif value == "SPACE":
        entry.insert(tkinter.END, ' ')
    elif value == " Tab ":
        entry.insert(tkinter.END, '    ')
    else :
        entry.insert(tkinter.END,value)
    
questions = []
file = open("/home/pi/zagadkomat/questions.txt", "r", encoding="utf-8")
line = file.readline()
while(line != ""):
    questionString = line
    answer = file.readline()
    answer = answer[:-1]
    questions.append(Question(questionString, answer))
    line = file.readline()
file.close()
index = -1
right = 0
number_of_questions = len(questions)    
    
    
buttons = [
'~','`','!','@','#','$','%','^','&','*','(',')','0','_','BACK',
'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p','\\','7','8','9','+',
'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l','[',']','4','5','6'
,'-',
'z', 'x', 'c', 'v', 'b', 'n', 'm', ',', '.','?','/','1','2','3','SPACE',
]

varRow = 4
varColumn = 0

for button in buttons:

        command = lambda x=button: select(x)
        
        if button == "SPACE" or button == "+" or button == "-" or button == "BACK":
            tkinter.Button(kb,text= button, width=8, font=("Century Gothic", 22), bg="#3c4987", fg="#ffffff",
                activebackground = "#ffffff", activeforeground="#3c4987", relief='raised', padx=2,
                pady=2, bd=0,command=command).grid(row=varRow,column=varColumn)

        else:
            tkinter.Button(kb,text= button, width=3, font=("Century Gothic", 22), bg="#3c4987", fg="#ffffff",
                activebackground = "#ffffff", activeforeground="#3c4987", relief='raised', padx=2,
                pady=2, bd=0,command=command).grid(row=varRow,column=varColumn)


        varColumn +=1 

        if varColumn > 14 and varRow == 4:
            varColumn = 0
            varRow+=1
        if varColumn > 14 and varRow == 5:
            varColumn = 0
            varRow+=1
        if varColumn > 14 and varRow == 6:
            varColumn = 0
            varRow+=1

labelo = Label(kb, font=("Century Gothic", 20), height=3, background='steelblue', text="")
labelo.grid(row=8,columnspan=15)

obrazeknormal()

buttonzwin = Button(kb, text="", borderwidth = 0, highlightthickness = 0, bg="steelblue", activebackground = "steelblue", font=("Century Gothic", 5), command=zwin)
buttonzwin.grid(row=0,column=0,rowspan=1,columnspan=1, sticky='nesw')

buttonrozwin = Button(kb, text="", borderwidth = 0, highlightthickness = 0, bg="steelblue", activebackground = "steelblue", font=("Century Gothic", 5), command=rozwin)
buttonrozwin.grid(row=0,column=14,rowspan=1,columnspan=1, sticky='nesw')

czesc = Label(kb, text="Cześć! Mam na imię Zagadkomat. Moja praca polega na tym, że przez zadawanie zagadek uczę logicznego myślenia. Czy chcesz odpowiedzieć na moje zagadki?", fg='white', bg="steelblue", font=("Century Gothic", 20), wraplength=500)
czesc.grid(row=1,column=5,rowspan=1,columnspan=10)

button = Button(kb, text="Rozpocznij grę", bg="#3c4987", fg="#ffffff", activebackground = "#ffffff", activeforeground="#3c4987", font=("Century Gothic", 40), height = 1, width = 15, command=askQuestion)
button.grid(row=2,column=5,rowspan=1,columnspan=10)

buttonkoniec = Button(kb, text="Zakończ", bg="#3c4987", fg="#ffffff", activebackground = "#ffffff", activeforeground="#3c4987", font=("Century Gothic", 15), command=koniec)
buttonkoniec.grid(row=8,column=14,rowspan=1,columnspan=1)

kb.mainloop()

